"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sfcUtils_1 = require("./sfcUtils");
const templateParser = __importStar(require("vue-eslint-parser"));
// @ts-ignore
const getParser_1 = __importDefault(require("jscodeshift/src/getParser"));
const jscodeshift_1 = __importDefault(require("jscodeshift"));
function vueSfcAstParse(fileInfo) {
    const { path, source } = fileInfo;
    let descriptor;
    const extension = (/\.([^.]*)$/.exec(path) || [])[0];
    if (extension !== '.vue') {
        return {};
    }
    // get vue sfc descriptor
    descriptor = sfcUtils_1.parse(source, { filename: path }).descriptor;
    const templateAST = parseTemplate(descriptor);
    const { scriptAST, jscodeshiftParser } = parseScript(descriptor);
    return {
        templateAST: templateAST,
        scriptAST: scriptAST,
        descriptor: descriptor,
        jscodeshiftParser: jscodeshiftParser
    };
}
exports.default = vueSfcAstParse;
function parseTemplate(descriptor) {
    if (!descriptor.template) {
        return null;
    }
    const templateContent = descriptor.template.ast.loc.source;
    const options = { sourceType: 'module' };
    const templateAST = templateParser.parse(templateContent, options);
    return templateAST;
}
function parseScript(descriptor) {
    if (!descriptor.script) {
        return null;
    }
    const lang = descriptor.script.lang || 'js';
    const scriptContent = descriptor.script.content;
    let parserOption = 'babylon';
    // force inject `parser` option for .tsx? files, unless the module specifies a custom implementation
    if (lang.startsWith('ts')) {
        parserOption = lang;
    }
    const parser = !!parserOption ? getParser_1.default(parserOption) : getParser_1.default();
    const jscodeshiftParser = jscodeshift_1.default.withParser(parser);
    const scriptAST = jscodeshiftParser(scriptContent);
    return { scriptAST, jscodeshiftParser };
}
//# sourceMappingURL=vue-sfc-ast-parser.js.map